#!/usr/bin/env python3

# Usage: ./renovate-ls-apps.py
#
# Output list of apps for Renovate bot configuration

from abralib import REPOS_TO_SKIP, get_repos_json


def main():
    """Run the script."""
    repos = [p["full_name"] for p in get_repos_json()]
    repos.sort()
    for repo in repos:
        if repo.split("/")[-1] in REPOS_TO_SKIP:
            continue
        print(f'"{repo}",')


main()
